<?xml version="1.0" encoding="UTF-8"?>
<!-- -*- coding: utf-8 -*- -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<!-- ********************************************************************** -->

<head>
  <!-- meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /> -->

  <title>HPCToolkit Publications</title>

  <link rel="stylesheet" type="text/css" href="style/style.css" />
</head>

<body>

<!-- ********************************************************************** -->

<!-- HPCToolkit Image (height = 71 pixels) --> <img style="position: absolute; top: 0px; left: 0px" src="style/header.gif" alt="hpctoolkit" /> <div style="position: relative; margin-top: 60px; width: 100%; text-align: right;"> <p style="margin: 0px; font-size: small;">   [ <a href="index.html">Home</a>     | <a href="overview.html">Overview</a>     | <a href="publications.html">Publications</a>     | <a href="software.html">Software/Downloads</a> ]   &bull;   [ <a href="documentation.html">Documentation/Questions</a>     | <a href="training.html">Training Videos and Slides</a> ]   &bull;   [ <a href="info-people.html">People</a>     | <a href="info-acks.html">Acks</a> ] </p> </div> <div style="width: 100%;">   <hr /> </div> 
<!-- ********************************************************************** -->

<h1>HPCToolkit and Related Publications</h1>

<h2>Selected Overview Paper</h2>

<!-- BEGIN CITATIONS pubs-overview -->
<!--
     \citation{Adhianto-etal:2010:CPE-hpctoolkit}
  -->
<!-- END CITATIONS pubs-overview -->

<!-- BEGIN BIBLIOGRAPHY pubs-overview -->
<!--
    DO NOT MODIFY THIS BIBLIOGRAPHY BY HAND!  IT IS MAINTAINED AUTOMATICALLY!
    YOUR CHANGES WILL BE LOST THE NEXT TIME IT IS UPDATED!
-->
<!-- Generated by: /home/johnmc/tmp/bib2xhtml/bib2xhtml -s unsort -i -d pubs-overview /home/johnmc/release-planning/hpctoolkit/doc/manual/texmf/bibtex/bib/pubs.bib /home/johnmc/release-planning/hpctoolkit/doc/www/publications.html.in -->
<dl class="bib2xhtml">

<!-- Authors: Adhianto Laksono and Banerjee Sinchan and Fagan Mike and Krentel
  Mark and Marin Gabriel and Mellor Crummey John and Tallent Nathan R -->
<dt><a
  name="Adhianto-etal:2010:CPE-hpctoolkit">[1]</a></dt><dd>Laksono
  Adhianto, Sinchan Banerjee, Mike Fagan,
  Mark Krentel, Gabriel Marin, John
  Mellor-Crummey, and Nathan&nbsp;R. Tallent.
HPCToolkit: Tools for performance analysis of optimized parallel programs.
<cite>Concurrency and Computation: Practice and Experience</cite>,
  22(6):685&ndash;701, 2010.
(<a href="http://www.hpctoolkit.org/pubs/cpe-2010-hpctoolkit.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1002/cpe.1553">doi:10.1002/cpe.1553</a>)</dd>

</dl>

<!-- END BIBLIOGRAPHY pubs-overview -->
<h2>HPCToolkit Papers</h2>

<!-- BEGIN CITATIONS pubs-hpctoolkit-a -->
<!--

     \citation{10.1145/3437801.3441604}
     \citation{9370339}
     \citation{9355258}
     \citation{9307876}
     \citation{10.1145/3392717.3392752}
     \citation{10.1145/3332466.3374534}
     \citation{10.1145/3332466.3374538}
     \citation{9070296}
     \citation{Taffet:2019}
     \citation{Gu:sc18}
     \citation{johnmc:piper17}
     \citation{Milind:lock16}
     \citation{Yang:spaa16}
     \citation{Murthy:16}
     \citation{Milind:16}
     \citation{Yang:16}
     \citation{Taffet:2016:ICPPW-hpctoolkit}
     \citation{Liu:2014:TAP:2555243.2555271:PPOPP-hpctoolkit}
     \citation{Liu:2014:TAP:2692916.2555271:Sigplan-hpctoolkit}
     \citation{Liu:2013:DPP:2503210.2503297:SC-hpctoolkit}
     \citation{Chabbi-etal:2013:hpctoolkit}
     \citation{Tallent-MC-etal:2011:ICS-hpctoolkit-scalable-tracing}
     \citation{Liu-MC:2011:CGO-hpctoolit-data-centric}
     \citation{Tallent-MC-etal:2010:SC-hpctoolkit-load-imbalance}
     \citation{Adhianto-MC-Ta:2010:PSTI-hpcviewer}
     \citation{Adhianto-etal:2010:CPE-hpctoolkit}
     \citation{Tallent-MC-Porterfield:2010:PPoPP-hpctoolkit-lock-contention}
     \citation{Tallent-MC:2009:IEEE-Computer}
     \citation{Tallent-MC-etal:2009:SC-hpctoolkit-petascale}
     \citation{Tallent-MC-Fagan:2009:PLDI-hpctoolkit-binary-analysis}
     \citation{Fowler-etal:2009:SciDAC-libra-hpctoolkit}
     \citation{Tallent-MC:2009:PPoPP-hpctoolkit-work-stealing}
     \citation{Adhianto-etal:2008:SC-NLPLSS-hpctoolkit}
     \citation{Tallent-etal:2008:SciDAC-hpctoolkit}
     \citation{MellorCrummey-Ta:2008:ISPASS-TIMERS-methodology}
     \citation{MellorCrummey-Ta-Fa-Od:2007:CUG-hpctoolkit}
     \citation{Coarfa-MC:2007:ICS-scalability}
     \citation{Froyd-Ta-MC-Fo:2006:GCCSummit-csprof}
     \citation{Froyd-MC-Fo:2005:ICS-csprof}
     \citation{MellorCrummey-Fo-Ma-Ta:2002:JoSC-hpcview}
     \citation{MellorCrummey-Fo-Wh:2001:ICS}

  John Mellor-Crummey, Robert Fowler, and Gabriel Marin. HPCView: A tool
  for top-down analysis of node performance. In <i>Proceedings of the Los
  Alamos Computer Science Institute Second Annual Symposium</i>, Santa Fe,
  NM, October 2001. Distributed on CD-ROM.
  <a href="http://www.cs.rice.edu/~johnmc/papers/hpcview-lacsi01-abstract.html">[abstract]</a>,
  <a  href="http://www.cs.rice.edu/~johnmc/papers/hpcview-lacsi01.ps">[ps]</a>,
  <a href="http://www.cs.rice.edu/~johnmc/papers/hpcview-lacsi01.pdf">[pdf]</a>

  -->
<!-- END CITATIONS pubs-hpctoolkit-a -->

<!-- BEGIN BIBLIOGRAPHY pubs-hpctoolkit-a -->
<!--
    DO NOT MODIFY THIS BIBLIOGRAPHY BY HAND!  IT IS MAINTAINED AUTOMATICALLY!
    YOUR CHANGES WILL BE LOST THE NEXT TIME IT IS UPDATED!
-->
<!-- Generated by: /home/johnmc/tmp/bib2xhtml/bib2xhtml -s unsort -i -d pubs-hpctoolkit-a /home/johnmc/release-planning/hpctoolkit/doc/manual/texmf/bibtex/bib/pubs.bib /home/johnmc/release-planning/hpctoolkit/doc/www/publications.html.in -->
<dl class="bib2xhtml">

<!-- Authors: Meng Xiaozhu and Anderson Jonathon M and Mellor Crummey John and
  Krentel Mark W and Miller Barton P and Milakovic Srdan -->
<!-- Keywords: performance analysis, operation dependencies and properties,
  control flow graph construction -->
<dt><a name="10.1145/3437801.3441604">[1]</a></dt><dd>Xiaozhu
  Meng, Jonathon&nbsp;M. Anderson, John
  Mellor-Crummey, Mark&nbsp;W. Krentel, Barton&nbsp;P.
  Miller, and Srdan Milakovic.
<a href="https://doi.org/10.1145/3437801.3441604">Parallel binary code
  analysis</a>.
In <cite>Proceedings of the 26th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, PPoPP '21, page 76–89, New York,
  NY, USA, 2021. Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/3437801.3441604">doi:10.1145/3437801.3441604</a>)</dd>

<!-- Authors: Zhou Keren and Meng Xiaozhu and Sai Ryuichi and Mellor Crummey
  John -->
<dt><a name="9370339">[2]</a></dt><dd>Keren Zhou,
  Xiaozhu Meng, Ryuichi Sai, and
  John Mellor-Crummey.
<a href="https://ieeexplore.ieee.org/document/9370339">GPA: A GPU performance
  advisor based on instruction sampling</a>.
In <cite>2021 IEEE/ACM International Symposium on Code Generation and
  Optimization (CGO)</cite>, pages 115&ndash;125, 2021.
(<a href="http://dx.doi.org/10.1109/CGO51591.2021.9370339">doi:10.1109/CGO51591.2021.9370339</a>)</dd>

<!-- Authors: K Zhou and Y Hao and J Mellor Crummey and X Meng and X Liu -->
<!-- Keywords: redundancy;graphics processing units;machine
  learning;production;kernel;optimization;monitoring -->
<dt><a name="9355258">[3]</a></dt><dd>K.&nbsp;Zhou,
  Y.&nbsp;Hao, J.&nbsp;Mellor-Crummey,
  X.&nbsp;Meng, and X.&nbsp;Liu.
<a href="https://doi.ieeecomputersociety.org/10.1109/SC41405.2020.00093">GVPROF:
  A value profiler for GPU-based clusters</a>.
In <cite>2020 SC20: International Conference for High Performance Computing,
  Networking, Storage and Analysis (SC)</cite>, pages 1&ndash;16, Los Alamitos, CA,
  USA, nov 2020. IEEE Computer Society.
(<a href="http://dx.doi.org/10.1109/SC41405.2020.00093">doi:10.1109/SC41405.2020.00093</a>)</dd>

<!-- Authors: Sai Ryuichi and Mellor Crummey John and Meng Xiaozhu and Araya
  Polo Mauricio and Meng Jie -->
<dt><a name="9307876">[4]</a></dt><dd>Ryuichi Sai,
  John Mellor-Crummey, Xiaozhu Meng,
  Mauricio Araya-Polo, and Jie Meng.
Accelerating high-order stencils on gpus.
In <cite>2020 IEEE/ACM Performance Modeling, Benchmarking and Simulation of
  High Performance Computer Systems (PMBS)</cite>, pages 86&ndash;108, 2020.
(<a href="http://dx.doi.org/10.1109/PMBS51919.2020.00014">doi:10.1109/PMBS51919.2020.00014</a>)</dd>

<!-- Authors: Zhou Keren and Krentel Mark W and Mellor Crummey John -->
<!-- Keywords: GPU, wait-free, roofline, calling context tree, profiler, HPC
  -->
<dt><a name="10.1145/3392717.3392752">[5]</a></dt><dd>Keren
  Zhou, Mark&nbsp;W. Krentel, and John
  Mellor-Crummey.
<a href="https://doi.org/10.1145/3392717.3392752">Tools for top-down
  performance analysis of GPU-accelerated applications</a>.
In <cite>Proceedings of the 34th ACM International Conference on
  Supercomputing</cite>, ICS '20, New York, NY, USA, 2020. Association for
  Computing Machinery.
(<a href="http://dx.doi.org/10.1145/3392717.3392752">doi:10.1145/3392717.3392752</a>)</dd>

<!-- Authors: Zhou Keren and Krentel Mark and Mellor Crummey John -->
<!-- Keywords: HPC, roofline, wait-free data structure, calling context tree,
  GPU, profiler -->
<dt><a name="10.1145/3332466.3374534">[6]</a></dt><dd>Keren
  Zhou, Mark Krentel, and John Mellor-Crummey.
<a href="https://doi.org/10.1145/3332466.3374534">A tool for top-down
  performance analysis of GPU-accelerated applications</a>.
In <cite>Proceedings of the 25th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, PPoPP '20, page 415–416, New York,
  NY, USA, 2020. Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/3332466.3374534">doi:10.1145/3332466.3374534</a>)</dd>

<!-- Authors: Wei Lai and Mellor Crummey John -->
<!-- Keywords: scalability losses, automated diagnosis, performance,
  sample-based time series data -->
<dt><a name="10.1145/3332466.3374538">[7]</a></dt><dd>Lai Wei
  and John Mellor-Crummey.
<a href="https://doi.org/10.1145/3332466.3374538">Using sample-based time
  series data for automated diagnosis of scalability losses in parallel
  programs</a>.
In <cite>Proceedings of the 25th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, PPoPP '20, pages 144&ndash;159, New York,
  NY, USA, 2020. Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/3332466.3374538">doi:10.1145/3332466.3374538</a>)</dd>

<!-- Authors: P Taffet and J Mellor Crummey -->
<dt><a name="9070296">[8]</a></dt><dd>P.&nbsp;Taffet and
  J.&nbsp;Mellor-Crummey.
Lightweight, packet-centric monitoring of network traffic and congestion
  implemented in p4.
In <cite>2019 IEEE Symposium on High-Performance Interconnects (HOTI)</cite>,
  pages 54&ndash;58, 2019.
(<a href="http://dx.doi.org/10.1109/HOTI.2019.00026">doi:10.1109/HOTI.2019.00026</a>)</dd>

<!-- Authors: Taffet Philip and Mellor Crummey John -->
<dt><a name="Taffet:2019">[9]</a></dt><dd>Philip Taffet and
  John Mellor-Crummey.
<a href="https://doi.org/10.1145/3295500.3356168">Understanding congestion in
  high performance interconnection networks using sampling</a>.
In <cite>Proceedings of the International Conference for High Performance
  Computing, Networking, Storage and Analysis</cite>, SC '19, New York, NY,
  USA, 2019. Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/3295500.3356168">doi:10.1145/3295500.3356168</a>)</dd>

<!-- Authors: Mellor Crummey John -->
<dt><a name="johnmc:piper17">[10]</a></dt><dd>John
  Mellor-Crummey.
Piper: Performance insight for programmers and exascale runtimes: Guiding the
  development of the exascale software stack.
10 2017.
(<a href="http://dx.doi.org/10.2172/1400393">doi:10.2172/1400393</a>)</dd>

<!-- Authors: Chabbi Milind and Mellor Crummey John -->
<!-- Keywords: dynamic locks, hierarchical locks, NUMA, spin locks -->
<dt><a name="Milind:lock16">[11]</a></dt><dd>Milind Chabbi and
  John Mellor-Crummey.
<a href="https://doi.org/10.1145/2851141.2851166">Contention-conscious,
  locality-preserving locks</a>.
In <cite>Proceedings of the 21st ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, PPoPP '16, New York, NY, USA, 2016.
  Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/2851141.2851166">doi:10.1145/2851141.2851166</a>)</dd>

<!-- Authors: Yang Chaoran and Mellor Crummey John -->
<!-- Keywords: cactus stack, work-stealing, interoperability -->
<dt><a name="Yang:spaa16">[12]</a></dt><dd>Chaoran Yang and
  John Mellor-Crummey.
<a href="https://doi.org/10.1145/2935764.2935787">A practical solution to the
  cactus stack problem</a>.
In <cite>Proceedings of the 28th ACM Symposium on Parallelism in Algorithms and
  Architectures</cite>, SPAA '16, page 61–70, New York, NY, USA, 2016.
  Association for Computing Machinery.
(<a href="http://dx.doi.org/10.1145/2935764.2935787">doi:10.1145/2935764.2935787</a>)</dd>

<!-- Authors: Taffet Philip and Adhianto Laksono -->
<!-- Keywords: client-server systems;data visualisation;multi-threading;ray
  tracing;software tools;huge call-path trace visualization;large-scale
  parallel systems;tracing;parallel programs;performance visualization
  tool;threads;parallel execution;client-server
  approach;hpctraceviewer;HPC-toolkit performance tools;algebraic
  multigrid;AMG;unstructured mesh transport;UMT codes;Servers;Optimization;Data
  visualization;Context;Supercomputers;Instruction sets;HPCToolkit;performance
  analysis;data traces;high performance computing -->
<dt><a
  name="Taffet:2016:ICPPW-hpctoolkit">[13]</a></dt><dd>Philip
  Taffet and Laksono Adhianto.
Addressing challenges in visualizing huge call-path traces.
In <cite>2016 45th International Conference on Parallel Processing Workshops
  (ICPPW)</cite>, pages 319&ndash;328, Aug 2016.
(<a href="http://dx.doi.org/10.1109/ICPPW.2016.53">doi:10.1109/ICPPW.2016.53</a>)</dd>

<!-- Authors: Liu Xu and Mellor Crummey John -->
<!-- Keywords: NUMA, memory access pattern, performance optimization, profiler,
  threads -->
<dt><a
  name="Liu:2014:TAP:2555243.2555271:PPOPP-hpctoolkit">[14]</a></dt><dd>Xu&nbsp;Liu
  and John Mellor-Crummey.
<a href="http://doi.acm.org/10.1145/2555243.2555271">A tool to analyze the
  performance of multithreaded programs on numa architectures</a>.
In <cite>Proceedings of the 19th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, PPoPP '14, pages 259&ndash;272, New York,
  NY, USA, 2014. ACM.
(<a href="http://dx.doi.org/10.1145/2555243.2555271">doi:10.1145/2555243.2555271</a>)</dd>

<!-- Authors: Liu Xu and Mellor Crummey John -->
<!-- Keywords: NUMA, memory access pattern, performance optimization, profiler,
  threads -->
<dt><a
  name="Liu:2014:TAP:2692916.2555271:Sigplan-hpctoolkit">[15]</a></dt><dd>Xu&nbsp;Liu
  and John Mellor-Crummey.
<a href="http://doi.acm.org/10.1145/2692916.2555271">A tool to analyze the
  performance of multithreaded programs on numa architectures</a>.
<cite>SIGPLAN Not.</cite>, 49(8):259&ndash;272, February 2014.
(<a href="http://dx.doi.org/10.1145/2692916.2555271">doi:10.1145/2692916.2555271</a>)</dd>

<!-- Authors: Liu Xu and Mellor Crummey John -->
<!-- Keywords: data locality, data-centric profiling, scalable profiler -->
<dt><a
  name="Liu:2013:DPP:2503210.2503297:SC-hpctoolkit">[16]</a></dt><dd>Xu&nbsp;Liu
  and John Mellor-Crummey.
<a href="http://doi.acm.org/10.1145/2503210.2503297">A data-centric profiler
  for parallel programs</a>.
In <cite>Proceedings of the International Conference on High Performance
  Computing, Networking, Storage and Analysis</cite>, SC '13, pages
  28:1&ndash;28:12, New York, NY, USA, 2013. ACM.
(<a href="http://dx.doi.org/10.1145/2503210.2503297">doi:10.1145/2503210.2503297</a>)</dd>

<!-- Authors: Chabbi Milind and Murthy Karthik and Fagan Mike and Mellor
  Crummey John -->
<!-- Keywords: talk -->
<dt><a name="Chabbi-etal:2013:hpctoolkit">[17]</a></dt><dd>Milind
  Chabbi, Karthik Murthy, Mike Fagan, and
  John Mellor-Crummey.
Critically missing pieces on accelerators: A performance tools perspective.
SC '13: Birds of a Feather Session: Critically Missing Pieces in Heterogeneous
  Accelerator Computing, Pavan Balaji (Organizer), November 2013.</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John M and Franco Michael and
  Landrum Reed and Adhianto Laksono -->
<dt><a
  name="Tallent-MC-etal:2011:ICS-hpctoolkit-scalable-tracing">[18]</a></dt><dd>Nathan&nbsp;R.
  Tallent, John&nbsp;M. Mellor-Crummey, Michael
  Franco, Reed Landrum, and Laksono Adhianto.
Scalable fine-grained call path tracing.
In <cite>ICS '11: Proc. of the 25th International Conference on
  Supercomputing</cite>, pages 63&ndash;74, New York, NY, USA, 2011. ACM.
(<a href="http://www.hpctoolkit.org/pubs/ics-2011-hpctoolkit-scalable-tracing.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1995896.1995908">doi:10.1145/1995896.1995908</a>)</dd>

<!-- Authors: Liu Xu and Mellor Crummey John -->
<dt><a
  name="Liu-MC:2011:CGO-hpctoolit-data-centric">[19]</a></dt><dd>Xu&nbsp;Liu
  and John Mellor-Crummey.
Pinpointing data locality problems using data-centric analysis.
In <cite>CGO '11: Proc. of the 2011 IEEE/ACM International Symposium on Code
  Generation and Optimization</cite>, pages 171&ndash;180, 2011.
(<a href="http://dx.doi.org/10.1109/CGO.2011.5764685">doi:10.1109/CGO.2011.5764685</a>)</dd>

<!-- Authors: Tallent Nathan R and Adhianto Laksono and Mellor Crummey John M
  -->
<dt><a
  name="Tallent-MC-etal:2010:SC-hpctoolkit-load-imbalance">[20]</a></dt><dd>Nathan&nbsp;R.
  Tallent, Laksono Adhianto, and John&nbsp;M.
  Mellor-Crummey.
Scalable identification of load imbalance in parallel executions using call
  path profiles.
In <cite>SC '10: Proc. of the 2010 ACM/IEEE Conference on
  Supercomputing</cite>, pages 1&ndash;11, Washington, DC, USA, 2010. IEEE Computer
  Society.
(<a href="http://www.hpctoolkit.org/pubs/sc-2010-hpctoolkit-load-imbalance.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1109/SC.2010.47">doi:10.1109/SC.2010.47</a>)</dd>

<!-- Authors: Adhianto Laksono and Mellor Crummey John and Tallent Nathan R -->
<dt><a
  name="Adhianto-MC-Ta:2010:PSTI-hpcviewer">[21]</a></dt><dd>Laksono
  Adhianto, John Mellor-Crummey, and Nathan&nbsp;R.
  Tallent.
Effectively presenting call path profiles of application performance.
In <cite>PSTI 2010: Workshop on Parallel Software Tools and Tool
  Infrastructures, in conjunction with the 2010 International Conference on
  Parallel Processing</cite>, 2010.
(<a href="http://www.hpctoolkit.org/pubs/psti-2010-hpcviewer.pdf">PDF</a>)</dd>

<!-- Authors: Adhianto Laksono and Banerjee Sinchan and Fagan Mike and Krentel
  Mark and Marin Gabriel and Mellor Crummey John and Tallent Nathan R -->
<dt><a
  name="Adhianto-etal:2010:CPE-hpctoolkit">[22]</a></dt><dd>Laksono
  Adhianto, Sinchan Banerjee, Mike Fagan,
  Mark Krentel, Gabriel Marin, John
  Mellor-Crummey, and Nathan&nbsp;R. Tallent.
HPCToolkit: Tools for performance analysis of optimized parallel programs.
<cite>Concurrency and Computation: Practice and Experience</cite>,
  22(6):685&ndash;701, 2010.
(<a href="http://www.hpctoolkit.org/pubs/cpe-2010-hpctoolkit.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1002/cpe.1553">doi:10.1002/cpe.1553</a>)</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John M and Porterfield Allan
  -->
<dt><a
  name="Tallent-MC-Porterfield:2010:PPoPP-hpctoolkit-lock-contention">[23]</a></dt><dd>Nathan&nbsp;R.
  Tallent, John&nbsp;M. Mellor-Crummey, and Allan
  Porterfield.
Analyzing lock contention in multithreaded applications.
In <cite>PPoPP '10: Proc. of the 15th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, pages 269&ndash;280, New York, NY, USA,
  2010. ACM.
(<a href="http://www.hpctoolkit.org/pubs/ppopp-2010-hpctoolkit-lock-contention.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1693453.1693489">doi:10.1145/1693453.1693489</a>)</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John M -->
<dt><a
  name="Tallent-MC:2009:IEEE-Computer">[24]</a></dt><dd>Nathan&nbsp;R.
  Tallent and John&nbsp;M. Mellor-Crummey.
Identifying performance bottlenecks in work-stealing computations.
<cite>Computer</cite>, 42(12):44&ndash;50, 2009.
(<a href="http://dx.doi.org/10.1109/MC.2009.396">doi:10.1109/MC.2009.396</a>)</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John M and Adhianto Laksono
  and Fagan Michael W and Krentel Mark -->
<dt><a
  name="Tallent-MC-etal:2009:SC-hpctoolkit-petascale">[25]</a></dt><dd>Nathan&nbsp;R.
  Tallent, John&nbsp;M. Mellor-Crummey, Laksono
  Adhianto, Michael&nbsp;W. Fagan, and Mark Krentel.
Diagnosing performance bottlenecks in emerging petascale applications.
In <cite>SC '09: Proc. of the 2009 ACM/IEEE Conference on
  Supercomputing</cite>, pages 1&ndash;11, New York, NY, USA, 2009. ACM.
(<a href="http://www.hpctoolkit.org/pubs/sc-2009-hpctoolkit-petascale.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1654059.1654111">doi:10.1145/1654059.1654111</a>)</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John and Fagan Michael W -->
<dt><a
  name="Tallent-MC-Fagan:2009:PLDI-hpctoolkit-binary-analysis">[26]</a></dt><dd>Nathan&nbsp;R.
  Tallent, John Mellor-Crummey, and Michael&nbsp;W.
  Fagan.
Binary analysis for measurement and attribution of program performance.
In <cite>PLDI '09: Proc. of the 2009 ACM SIGPLAN Conference on Programming
  Language Design and Implementation</cite>, pages 441&ndash;452, New York, NY, USA,
  2009. ACM.
<b>Distinguished Paper</b>.
(<a href="http://www.hpctoolkit.org/pubs/pldi-2009-hpctoolkit-binary-analysis.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1542476.1542526">doi:10.1145/1542476.1542526</a>)</dd>

<!-- Authors: Fowler Robert and Adhianto Laksono and de Supinski Bronis and
  Fagan Michael and Gamblin Todd and Krentel Mark and Mellor Crummey John and
  Schulz Martin and Tallent Nathan -->
<dt><a
  name="Fowler-etal:2009:SciDAC-libra-hpctoolkit">[27]</a></dt><dd>Robert
  Fowler, Laksono Adhianto, Bronis de&nbsp;Supinski,
  Michael Fagan, Todd Gamblin, Mark
  Krentel, John Mellor-Crummey, Martin Schulz,
  and Nathan Tallent.
<a href="http://stacks.iop.org/1742-6596/180/012041">Frontiers of performance
  analysis on leadership-class systems</a>.
<cite>Journal of Physics: Conference Series</cite>, 180:012041 (6pp),
  2009.</dd>

<!-- Authors: Tallent Nathan R and Mellor Crummey John -->
<dt><a
  name="Tallent-MC:2009:PPoPP-hpctoolkit-work-stealing">[28]</a></dt><dd>Nathan&nbsp;R.
  Tallent and John Mellor-Crummey.
Effective performance measurement and analysis of multithreaded applications.
In <cite>PPoPP '09: Proc. of the 14th ACM SIGPLAN Symposium on Principles and
  Practice of Parallel Programming</cite>, pages 229&ndash;240, New York, NY, USA,
  2009. ACM.
(<a href="http://www.hpctoolkit.org/pubs/ppopp-2009-hpctoolkit-work-stealing.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1504176.1504210">doi:10.1145/1504176.1504210</a>)</dd>

<!-- Authors: Adhianto L and Fagan M and Krentel M and Marin G and Mellor
  Crummey J and Tallent N R -->
<dt><a
  name="Adhianto-etal:2008:SC-NLPLSS-hpctoolkit">[29]</a></dt><dd>L.&nbsp;Adhianto,
  M.&nbsp;Fagan, M.&nbsp;Krentel, G.&nbsp;Marin,
  J.&nbsp;Mellor-Crummey, and N.&nbsp;R. Tallent.
HPCToolkit: Performance measurement and analysis for supercomputers with
  node-level parallelism.
In <cite>Workshop on Node Level Parallelism for Large Scale Supercomputers, in
  conjunction with Supercomputing 2008</cite>, November 2008.</dd>

<!-- Authors: Tallent Nathan and Mellor Crummey John and Adhianto Laksono and
  Fagan Mike and Krentel Mark -->
<dt><a
  name="Tallent-etal:2008:SciDAC-hpctoolkit">[30]</a></dt><dd>Nathan
  Tallent, John Mellor-Crummey, Laksono
  Adhianto, Mike Fagan, and Mark Krentel.
<a href="http://stacks.iop.org/1742-6596/125/012088">HPCToolkit: Performance
  tools for scientific computing</a>.
<cite>Journal of Physics: Conference Series</cite>, 125:012088 (5pp),
  2008.</dd>

<!-- Authors: Mellor Crummey John and Tallent Nathan R -->
<dt><a
  name="MellorCrummey-Ta:2008:ISPASS-TIMERS-methodology">[31]</a></dt><dd>John
  Mellor-Crummey and Nathan&nbsp;R. Tallent.
A methodology for accurate, effective and scalable performance analysis of
  application programs.
In <cite>Workshop on Tools, Infrastructures and Methodologies for the
  Evaluation of Research Systems, in conjunction with the 2008 IEEE
  International Symposium on Performance Analysis of Systems and
  Software</cite>, pages 4&ndash;11, February 2008.</dd>

<!-- Authors: Mellor Crummey John and Tallent Nathan R and Fagan Mike and
  Odegard Jan -->
<dt><a
  name="MellorCrummey-Ta-Fa-Od:2007:CUG-hpctoolkit">[32]</a></dt><dd>John
  Mellor-Crummey, Nathan&nbsp;R. Tallent, Mike
  Fagan, and Jan Odegard.
Application performance profiling on the Cray XD1 using HPCToolkit.
In <cite>Proc. of the Cray User's Group</cite>, May 2007.</dd>

<!-- Authors: Coarfa Cristian and Mellor Crummey John and Froyd Nathan and
  Dotsenko Yuri -->
<dt><a
  name="Coarfa-MC:2007:ICS-scalability">[33]</a></dt><dd>Cristian
  Coarfa, John Mellor-Crummey, Nathan Froyd, and
  Yuri Dotsenko.
Scalability analysis of SPMD codes using expectations.
In <cite>ICS '07: Proc. of the 21st International Conference on
  Supercomputing</cite>, pages 13&ndash;22, New York, NY, USA, 2007. ACM.
(<a href="http://dx.doi.org/10.1145/1274971.1274976">doi:10.1145/1274971.1274976</a>)</dd>

<!-- Authors: Froyd Nathan and Tallent Nathan and Mellor Crummey John and
  Fowler Robert -->
<dt><a
  name="Froyd-Ta-MC-Fo:2006:GCCSummit-csprof">[34]</a></dt><dd>Nathan
  Froyd, Nathan Tallent, John Mellor-Crummey,
  and Robert Fowler.
Call path profiling for unmodified, optimized binaries.
In <cite>GCC Summit '06: Proc. of the GCC Developers' Summit, 2006</cite>,
  pages 21&ndash;36, 2006.</dd>

<!-- Authors: Froyd Nathan and Mellor Crummey John and Fowler Rob -->
<dt><a name="Froyd-MC-Fo:2005:ICS-csprof">[35]</a></dt><dd>Nathan
  Froyd, John Mellor-Crummey, and Rob Fowler.
Low-overhead call path profiling of unmodified, optimized code.
In <cite>Proc. of the 19th International Conference on Supercomputing</cite>,
  pages 81&ndash;90, New York, NY, USA, 2005. ACM.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/papers/csprof-ics05.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1088149.1088161">doi:10.1145/1088149.1088161</a>)</dd>

<!-- Authors: Mellor Crummey John and Fowler Robert and Marin Gabriel and
  Tallent Nathan -->
<dt><a
  name="MellorCrummey-Fo-Ma-Ta:2002:JoSC-hpcview">[36]</a></dt><dd>John
  Mellor-Crummey, Robert Fowler, Gabriel
  Marin, and Nathan Tallent.
HPCView: A tool for top-down analysis of node performance.
<cite>The Journal of Supercomputing</cite>, 23(1):81&ndash;104, 2002.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/papers/hpcview-tjs02.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1023/A:1015789220266">doi:10.1023/A:1015789220266</a>)</dd>

<!-- Authors: Mellor Crummey John and Fowler Robert and Whalley David -->
<dt><a name="MellorCrummey-Fo-Wh:2001:ICS">[37]</a></dt><dd>John
  Mellor-Crummey, Robert Fowler, and David
  Whalley.
Tools for application-oriented performance tuning.
In <cite>ICS '01: Proc. of the 15th International Conference on
  Supercomputing</cite>, pages 154&ndash;165, New York, NY, USA, 2001. ACM.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/papers/perftools-ics01.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/377792.377826">doi:10.1145/377792.377826</a>)</dd>

</dl>

<!-- END BIBLIOGRAPHY pubs-hpctoolkit-a -->
<h2>HPCToolkit Talks and Posters</h2>

<!-- BEGIN CITATIONS pubs-hpctoolkit-b -->
<!--
     \citation{Chabbi-etal:2013:hpctoolkit}
     \citation{Mellor-Crummey:talk:2011:alcf-workshop}
     \citation{Tallent:talk:2010:SC-hpctoolkit}
     \citation{Mellor-Crummey:talk:2010:IBM-hpctoolkit}
     \citation{Mellor-Crummey:talk:2010:SciDAC-hpctoolkit}
     \citation{Tallent:talk:2010:Dagstuhl-hpctoolkit}
     \citation{Mellor-Crummey:talk:2010:alcf-workshop}
     \citation{Tallent:talk:2009:SC-hpctoolkit}
     \citation{Adhianto-etal:poster:2008:SC-hpctoolkit}
     \citation{MC-Fowler-Tallent:talk:2004:SC-hpctoolkit}
     \citation{Mellor-Crummey:talk:2003:APART-hpctoolkit}
     \citation{Froyd-MC-Ta:poster:2003:csprof}
     \citation{Tallent:talk:2003:ANL-hpctoolkit}
     \citation{MellorCrummey-Fo-Wh:poster:2001:MMCS}
  -->
<!-- END CITATIONS pubs-hpctoolkit-b -->

<!-- BEGIN BIBLIOGRAPHY pubs-hpctoolkit-b -->
<!--
    DO NOT MODIFY THIS BIBLIOGRAPHY BY HAND!  IT IS MAINTAINED AUTOMATICALLY!
    YOUR CHANGES WILL BE LOST THE NEXT TIME IT IS UPDATED!
-->
<!-- Generated by: /home/johnmc/tmp/bib2xhtml/bib2xhtml -s unsort -i -d pubs-hpctoolkit-b /home/johnmc/release-planning/hpctoolkit/doc/manual/texmf/bibtex/bib/pubs.bib /home/johnmc/release-planning/hpctoolkit/doc/www/publications.html.in -->
<dl class="bib2xhtml">

<!-- Authors: Chabbi Milind and Murthy Karthik and Fagan Mike and Mellor
  Crummey John -->
<!-- Keywords: talk -->
<dt><a name="Chabbi-etal:2013:hpctoolkit">[1]</a></dt><dd>Milind
  Chabbi, Karthik Murthy, Mike Fagan, and
  John Mellor-Crummey.
Critically missing pieces on accelerators: A performance tools perspective.
SC '13: Birds of a Feather Session: Critically Missing Pieces in Heterogeneous
  Accelerator Computing, Pavan Balaji (Organizer), November 2013.</dd>

<!-- Authors: Mellor Crummey John -->
<!-- Keywords: talk -->
<dt><a
  name="Mellor-Crummey:talk:2011:alcf-workshop">[2]</a></dt><dd>John
  Mellor-Crummey.
Hpctoolkit: Sampling-based performance tools for leadership computing.
Productivity Tools for Leadership Science Workshop, Argonne Leadership
  Computing Facility Winter Workshop Series, January 2011.</dd>

<!-- Authors: Tallent Nathan R -->
<!-- Keywords: talk -->
<dt><a
  name="Tallent:talk:2010:SC-hpctoolkit">[3]</a></dt><dd>Nathan&nbsp;R.
  Tallent.
Performance analysis for parallel programs: From multicore to petascale.
Supercomputing 2010 George Michael HPC Fellow Presentation, November
  2010.</dd>

<!-- Authors: Mellor Crummey John -->
<!-- Keywords: talk -->
<dt><a
  name="Mellor-Crummey:talk:2010:IBM-hpctoolkit">[4]</a></dt><dd>John
  Mellor-Crummey.
Gaining insight into parallel program performance using sampling.
IBM T. J. Watson Research Center, October 2010.</dd>

<!-- Authors: Mellor Crummey John -->
<!-- Keywords: talk -->
<dt><a
  name="Mellor-Crummey:talk:2010:SciDAC-hpctoolkit">[5]</a></dt><dd>John
  Mellor-Crummey.
A slice of CScADS: Performance tools for petascale platforms.
SciDAC 2010, July 2010.</dd>

<!-- Authors: Tallent Nathan R -->
<!-- Keywords: talk -->
<dt><a
  name="Tallent:talk:2010:Dagstuhl-hpctoolkit">[6]</a></dt><dd>Nathan&nbsp;R.
  Tallent.
<a href="http://drops.dagstuhl.de/opus/volltexte/2010/2684">Identifying
  scalability bottlenecks in large-scale parallel programs using
  HPCToolkit</a>.
In Jesus Labarta, Barton&nbsp;P. Miller,
  Bernd Mohr, and Martin Schulz, editors,
  <cite>Program Development for Extreme-Scale Computing</cite>, number 10181 in
  Dagstuhl Seminar Proceedings, Dagstuhl, Germany, 2010. Schloss Dagstuhl -
  Leibniz-Zentrum fuer Informatik, Germany.</dd>

<!-- Authors: Mellor Crummey John -->
<!-- Keywords: talk -->
<dt><a
  name="Mellor-Crummey:talk:2010:alcf-workshop">[7]</a></dt><dd>John
  Mellor-Crummey.
Hpctoolkit: Sampling-based performance tools for leadership computing.
INCITE Getting Started Workshop, Argonne Leadership Computing Facility, January
  2010.</dd>

<!-- Authors: Tallent Nathan R -->
<!-- Keywords: talk -->
<dt><a
  name="Tallent:talk:2009:SC-hpctoolkit">[8]</a></dt><dd>Nathan&nbsp;R.
  Tallent.
Performance analysis of parallel programs: From multicore to petascale.
Supercomputing 2009 Doctoral Research Showcase, November 2009.</dd>

<!-- Authors: Adhianto L and Banerjee S and Fagan M and Krentel M and Marin G
  and Mellor Crummey J and Tallent N R -->
<!-- Keywords: poster -->
<dt><a
  name="Adhianto-etal:poster:2008:SC-hpctoolkit">[9]</a></dt><dd>L.&nbsp;Adhianto,
  S.&nbsp;Banerjee, M.&nbsp;Fagan,
  M.&nbsp;Krentel, G.&nbsp;Marin,
  J.&nbsp;Mellor-Crummey, and N.&nbsp;R. Tallent.
HPCToolkit: Performance tools for scientific computing.
In <cite>SC '08: Proc. of the 2008 ACM/IEEE Conference on
  Supercomputing</cite>, New York, NY, USA, 2008. ACM.</dd>

<!-- Authors: Mellor Crummey John and Fowler Robert and Tallent Nathan R -->
<!-- Keywords: talk -->
<dt><a
  name="MC-Fowler-Tallent:talk:2004:SC-hpctoolkit">[10]</a></dt><dd>John
  Mellor-Crummey, Robert Fowler, and Nathan&nbsp;R.
  Tallent.
Practical application performance analysis on Linux systems.
Supercomputing 2004 Tutorial, November 2004.</dd>

<!-- Authors: Mellor Crummey John -->
<!-- Keywords: talk -->
<dt><a
  name="Mellor-Crummey:talk:2003:APART-hpctoolkit">[11]</a></dt><dd>John
  Mellor-Crummey.
HPCToolkit: Multi-platform tools for profile-based performance analysis.
5th International Workshop on Automatic Performance Analysis (APART), November
  2003.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/presentations/HPCToolkit-APART-2003-11.pdf">PDF</a>)</dd>

<!-- Authors: Froyd Nathan and Mellor Crummey John and Tallent Nathan R -->
<!-- Keywords: poster -->
<dt><a
  name="Froyd-MC-Ta:poster:2003:csprof">[12]</a></dt><dd>Nathan
  Froyd, John Mellor-Crummey, and Nathan&nbsp;R.
  Tallent.
A sample-driven call stack profiler.
4th Symposium of the Los Alamos Computer Science Institute (LACSI 2003),
  October 2003.</dd>

<!-- Authors: Tallent Nathan R -->
<!-- Keywords: talk -->
<dt><a
  name="Tallent:talk:2003:ANL-hpctoolkit">[13]</a></dt><dd>Nathan&nbsp;R.
  Tallent.
HPCToolkit: Top-down analysis of node performance.
2003 MCS Divisional Seminars and Colloquia, Argonne National Laboratory, August
  2003.</dd>

<!-- Authors: Mellor Crummey John and Fowler Robert and Whalley David -->
<!-- Keywords: poster -->
<dt><a
  name="MellorCrummey-Fo-Wh:poster:2001:MMCS">[14]</a></dt><dd>John
  Mellor-Crummey, Robert Fowler, and David
  Whalley.
On providing useful information for analyzing and tuning applications.
In <cite>SIGMETRICS '01: Proc. of the 2001 ACM SIGMETRICS International
  Conference on Measurement and Modeling of Computer Systems</cite>, pages
  332&ndash;333, New York, NY, USA, 2001. ACM.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/papers/perftools-sigmetrics01.ps">PDF</a>)
(<a href="http://dx.doi.org/10.1145/378420.378828">doi:10.1145/378420.378828</a>)</dd>

</dl>

<!-- END BIBLIOGRAPHY pubs-hpctoolkit-b -->
<h2>Performance Modeling and Prediction Papers</h2>

<!-- BEGIN CITATIONS pubs-prediction -->
<!--
     \citation{Marin-MC:2007:IPCCC-insight}
     \citation{Qasem-Kennedy-MC:2006:JoS-autotuning-search}
     \citation{Marin-MC:2005:scalable-prediction}
     \citation{Marin-MC:2004:SIGMETRICS-prediction}
  -->
<!-- END CITATIONS pubs-prediction -->

<!-- BEGIN BIBLIOGRAPHY pubs-prediction -->
<!--
    DO NOT MODIFY THIS BIBLIOGRAPHY BY HAND!  IT IS MAINTAINED AUTOMATICALLY!
    YOUR CHANGES WILL BE LOST THE NEXT TIME IT IS UPDATED!
-->
<!-- Generated by: /home/johnmc/tmp/bib2xhtml/bib2xhtml -s unsort -i -d pubs-prediction /home/johnmc/release-planning/hpctoolkit/doc/manual/texmf/bibtex/bib/pubs.bib /home/johnmc/release-planning/hpctoolkit/doc/www/publications.html.in -->
<dl class="bib2xhtml">

<!-- Authors: Marin G and Mellor Crummey J -->
<dt><a
  name="Marin-MC:2007:IPCCC-insight">[1]</a></dt><dd>G.&nbsp;Marin
  and J.&nbsp;Mellor-Crummey.
Application insight through performance modeling.
In <cite>IPCCC 2007: Proc. of the 26th IEEE International Performance,
  Computing, and Communications Conference</cite>, pages 65 &ndash;74, apr. 2007.
(<a href="http://www.hpctoolkit.org/pubs/marin-mellor-crummey-ipccc07.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1109/PCCC.2007.358880">doi:10.1109/PCCC.2007.358880</a>)</dd>

<!-- Authors: Qasem Apan and Kennedy Ken and Mellor Crummey John -->
<dt><a
  name="Qasem-Kennedy-MC:2006:JoS-autotuning-search">[2]</a></dt><dd>Apan
  Qasem, Ken Kennedy, and John Mellor-Crummey.
Automatic tuning of whole applications using direct search and a
  performance-based transformation system.
<cite>J. Supercomput.</cite>, 36(2):183&ndash;196, 2006.
(<a href="http://www.cs.rice.edu/&nbsp;qasem/papers/jos06.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1007/s11227-006-7957-2">doi:10.1007/s11227-006-7957-2</a>)</dd>

<!-- Authors: Marin Gabriel and Mellor Crummey John -->
<dt><a
  name="Marin-MC:2005:scalable-prediction">[3]</a></dt><dd>Gabriel
  Marin and John Mellor-Crummey.
Scalable cross-architecture predictions of memory hierarchy response for
  scientific applications.
In <cite>Proc. of the Sixth Annual Los Alamos Computer Science Institute
  Symposium</cite>, 2005.
(<a href="http://www.hpctoolkit.org/pubs/MM-lacsi05.pdf">PDF</a>)</dd>

<!-- Authors: Marin Gabriel and Mellor Crummey John -->
<dt><a
  name="Marin-MC:2004:SIGMETRICS-prediction">[4]</a></dt><dd>Gabriel
  Marin and John Mellor-Crummey.
Cross-architecture performance predictions for scientific applications using
  parameterized models.
In <cite>SIGMETRICS '04: Proc. of the Joint International Conference on
  Measurement and Modeling of Computer Systems</cite>, pages 2&ndash;13, New York,
  NY, USA, 2004. ACM.
(<a href="http://www.cs.rice.edu/&nbsp;johnmc/papers/MM-SIGMETRICS04.pdf">PDF</a>)
(<a href="http://dx.doi.org/10.1145/1005686.1005691">doi:10.1145/1005686.1005691</a>)</dd>

</dl>

<!-- END BIBLIOGRAPHY pubs-prediction -->
<!-- ********************************************************************** -->

<p>[Made with <a href="http://www.spinellis.gr/sw/textproc/bib2xhtml/">bib2xhtml</a>.]
</p>

<p>[<span class="lastupdated">Page last updated: 2011/06/25</span>]
</p>

<!-- ********************************************************************** -->

<div style="width: 100%; font-size: small;">   <hr />   <p style="margin: 0px; font-size: small;">     &copy;2002-2023 <a href="http://www.rice.edu">Rice University</a>     &bull;     <a href="http://www.cs.rice.edu">Rice Computer Science</a>   </p>   <a href="http://validator.w3.org/check/referer">     <img src="http://www.w3.org/Icons/valid-xhtml10-blue" alt="" height="15" /></a>   <a href="http://jigsaw.w3.org/css-validator/check/referer">     <img src="http://www.w3.org/Icons/valid-css-blue" alt="" height="15" /></a> </div> 
<!-- ********************************************************************** -->

</body>
</html>

<!-- Local Variables: -->
<!-- eval: (add-hook 'write-file-hooks 'time-stamp) -->
<!-- time-stamp-start: "<span class=\"lastupdated\">Page last updated: " -->
<!-- time-stamp-format: "%:y/%02m/%02d" -->
<!-- time-stamp-end: "</span>" -->
<!-- time-stamp-line-limit: 10000 -->
<!-- End: -->
